"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const TestResolver_1 = require("../src/system/TestResolver");
const clone_1 = require("../src/commands/clone");
require("isomorphic-fetch");
const TestOut_1 = require("../src/system/TestOut");
const fetchMock = require('fetch-mock');
const debug = require('debug')('graphcool');
/*
 Tests:
- Succeeding project clone with specific name
- Succeeding project clone with specific name and different output path
- Succeeding project clone with specific name and project ID
- Succeeding project clone with specific name, project file and output path
- Failing because no project ID provided (no project file in current directory)
 */
ava_1.default.afterEach(() => {
    fetchMock.restore();
});
ava_1.default('Default test', (t) => __awaiter(this, void 0, void 0, function* () {
    t.pass();
}));
// test('Succeeding project clone with specific name', async t => {
//
//   // configure HTTP mocks
//   fetchMock.post(systemAPIEndpoint, JSON.parse(mockedClonedProjectResponse))
//
//   // create dummy project data
//   const clonedProjectName = `Clone of MyProject`
//   const props = {name: clonedProjectName}
//
//   // prepare environment
//   const env = testEnvironment({})
//   const projectFilePath = graphcoolProjectFileName
//   env.resolver.write(projectFilePath, mockProjectFile1)
//   env.resolver.write(graphcoolConfigFilePath, '{"token": "abcdefgh"}')
//
//   env.out.prefix((t as any)._test.title, `$ graphcool clone -n "Clone of MyProject"`)
//
//   await t.notThrows(
//     cloneCommand(props, env)
//   )
//
//   const expectedProjectFileContent = clonedMockProjectFile1
//   const clonedProjectFileName = graphcoolCloneProjectFileName(projectFilePath)
//   t.is(env.resolver.read(clonedProjectFileName), expectedProjectFileContent)
//   t.is(readProjectIdFromProjectFile(env.resolver, clonedProjectFileName), 'nmlkjihgfedcba')
//   t.is(readVersionFromProjectFile(env.resolver, clonedProjectFileName), '1')
// })
//
// test('Succeeding project clone with specific name and different output path', async t => {
//
//   // configure HTTP mocks
//   fetchMock.post(systemAPIEndpoint, JSON.parse(mockedClonedProjectResponse))
//
//   // create dummy project data
//   const clonedProjectName = `Clone of MyProject`
//   const outputPath = `myclone.graphcool`
//   const props = {name: clonedProjectName, outputPath}
//
//   // prepare environment
//   const env = testEnvironment({})
//   const projectFilePath = graphcoolProjectFileName
//   env.resolver.write(projectFilePath, mockProjectFile1)
//   env.resolver.write(graphcoolConfigFilePath, '{"token": "abcdefgh"}')
//
//   env.out.prefix((t as any)._test.title, `$ graphcool clone -n "Clone of MyProject" -o ${outputPath}`)
//
//   await t.notThrows(
//     cloneCommand(props, env)
//   )
//
//   const expectedProjectFileContent = clonedMockProjectFile1
//   const clonedProjectFileName = outputPath
//   t.is(env.resolver.read(clonedProjectFileName), expectedProjectFileContent)
//   t.is(readProjectIdFromProjectFile(env.resolver, clonedProjectFileName), 'nmlkjihgfedcba')
//   t.is(readVersionFromProjectFile(env.resolver, clonedProjectFileName), '1')
// })
//
// test('Succeeding project clone with specific name and project ID', async t => {
//
//   // configure HTTP mocks
//   fetchMock.post(systemAPIEndpoint, JSON.parse(mockedClonedProjectResponse))
//
//   // create dummy project data
//   const clonedProjectName = `Clone of MyProject`
//   const sourceProjectId = `abcdefghijklmn`
//   const props = {name: clonedProjectName, sourceProjectId}
//
//   // prepare environment
//   const env = testEnvironment({})
//   env.resolver.write(graphcoolConfigFilePath, '{"token": "abcdefgh"}')
//
//   env.out.prefix((t as any)._test.title, `$ graphcool clone -n "Clone of MyProject" -s ${sourceProjectId}`)
//
//   await t.notThrows(
//     cloneCommand(props, env)
//   )
//
//   const expectedProjectFileContent = clonedMockProjectFile1
//   const clonedProjectFileName = graphcoolCloneProjectFileName(graphcoolProjectFileName)
//   t.is(env.resolver.read(clonedProjectFileName), expectedProjectFileContent)
//   t.is(readProjectIdFromProjectFile(env.resolver, clonedProjectFileName), 'nmlkjihgfedcba')
//   t.is(readVersionFromProjectFile(env.resolver, clonedProjectFileName), '1')
//
// })
//
// test('Succeeding project clone with specific name, project file and output path', async t => {
//
//   // configure HTTP mocks
//   fetchMock.post(systemAPIEndpoint, JSON.parse(mockedClonedProjectResponse))
//
//   // create dummy project data
//   const clonedProjectName = `Clone of MyProject`
//   const projectFile = `example.graphcool`
//   const props = {name: clonedProjectName, projectFile}
//
//   // prepare environment
//   const env = testEnvironment({})
//   env.resolver.write(graphcoolConfigFilePath, '{"token": "abcdefgh"}')
//   env.resolver.write(projectFile, mockProjectFile1)
//
//   env.out.prefix((t as any)._test.title, `$ graphcool clone -n "Clone of MyProject" -p ${projectFile}`)
//
//   await t.notThrows(
//     cloneCommand(props, env)
//   )
//
//   // make sure the original project file wasn't overridden
//   t.is(env.resolver.read(projectFile), mockProjectFile1)
//
//   const expectedProjectFileContent = clonedMockProjectFile1
//   const clonedProjectFileName = graphcoolCloneProjectFileName(projectFile)
//   t.is(env.resolver.read(clonedProjectFileName), expectedProjectFileContent)
//   t.is(readProjectIdFromProjectFile(env.resolver, clonedProjectFileName), 'nmlkjihgfedcba')
//   t.is(readVersionFromProjectFile(env.resolver, clonedProjectFileName), '1')
//
// })
//
// test('Failing because no project ID provided (no project file in current directory)', async t => {
//
//   // configure HTTP mocks
//   fetchMock.post(systemAPIEndpoint, JSON.parse(mockedClonedProjectResponse))
//
//   // create dummy project data
//   const clonedProjectName = `Clone of MyProject`
//   const props = {name: clonedProjectName}
//
//   // prepare environment
//   const env = testEnvironment({})
//   env.resolver.write(graphcoolConfigFilePath, '{"token": "abcdefgh"}')
//
//   env.out.prefix((t as any)._test.title, `$ graphcool clone -n "Clone of MyProject"`)
//
//   await t.throws(
//     clone(props, env)
//   )
//
// })
function clone(props, env) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            yield clone_1.default(props, env);
        }
        catch (e) {
            env.out.onError(e);
            throw e;
        }
    });
}
function testEnvironment(storage) {
    return {
        resolver: new TestResolver_1.default(storage),
        out: new TestOut_1.default(),
    };
}
//# sourceMappingURL=clone.test.js.map